IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc

    get_random_seed PROTO

    .code

start:
   
; 

    call main
    ;;; inkey
    exit

; 

main proc

    LOCAL hFile     :DWORD
    LOCAL unused    :DWORD
    LOCAL buff[16]  :BYTE
    LOCAL pbuf      :DWORD

    print "Writing RANDPAD.TXT",13,10

    mov hFile, fcreate("randpad.txt")

    push esi
    push edi
    xor esi, esi
    mov pbuf, ptr$(buff)
    mov edi, pbuf

  lbl0:
    invoke get_random_seed
    mov [edi], eax
    mov unused, fwrite(hFile,pbuf,4)
    add esi, 1
    cmp esi, 250000
    jl lbl0

    pop edi
    pop esi

    fclose hFile

    print "Done",13,10

    ret

main endp

; 

get_random_seed proc

    LOCAL num   :DWORD
    LOCAL rcnt  :DWORD
    LOCAL number$ :DWORD

    LOCAL pbuf  :DWORD
    LOCAL buffer[64]:BYTE

    LOCAL imnum1 :DWORD

    cpuid                           ; serialising instruction for wider seperation
                                    ; of results from RDTSC
    pause                           ; spinlock delay instruction

    rdtsc
    mov num, eax                    ; use the low dword of RDTSC return value
    mov number$, rev$(ustr$(num))   ; convert to string and reverse string
    mov num, uval(left$(number$,10)); read up to 10 characters from left side of string

    mov pbuf, ptr$(buffer)          ; get buffer address
    cst pbuf, number$               ; copy result to buffer
    mov pbuf, left$(pbuf,2)         ; get the left 2 bytes  0 - 99
    mov rcnt, uval(pbuf)            ; create the rotation count

    cpuid                           ; serialising instruction for wider seperation
                                    ; of results from RDTSC
    pause                           ; spinlock delay instruction

    mov eax, num
    mov ecx, rcnt
    rol eax, cl                     ; rotate LEFT 1st result by CL count
    mov imnum1, eax

    rdtsc
    mov num, eax
    mov number$, rev$(ustr$(num))   ; convert to string and reverse string
    mov num, uval(left$(number$,10)); read up to 10 characters from left side of string

    mov eax, num
    mov ecx, rcnt
    ror eax, cl                     ; rotate RIGHT 2nd result by CL count

    xor eax, imnum1                 ; XOR the two results

    ret

get_random_seed endp

; 

end start

